package alphabet;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Objects;

public class Wort implements Iterable<Zeichen>, Cloneable{
	
	public Wort(Zeichen... str) {

	}
	
	public Wort(String text) {

	}
	
  /**
   * Verwandelt uebergebenen String in ein Wort. 
   * Sollte die Zuordnung nicht moeglich sein, wird eine
   * IllegalStateException ausgegeben.
   * @param s umzuwandelnder String
   * @return resultierendes Wort
   * @throws IllegalStateException
   */
  public static Wort stringAlsWort(String s) {
 
    return null;
  }
	
	/** Das uebergebene Zeichen wird an das Wort angehaengt.
	 * 
	 * @param z anzuhaengendes Zeichen
	 * @return Wort mit neuem Zeichen am Ende
	 */
	public Wort anfuegen(Zeichen z) {
	  return this;
	}
	
	 /** Das uebergebene Zeichen wird vor das Wort gehaengt.
   * 
   * @param z neues erstes Zeichen
   * @return Wort mit neuem Anfangszeichen
   */
  public Wort vorne(Zeichen z) {
    return this;
  }
	
	/** Es kann ueber alle Zeichen des Wortes iteriert werden.
	 * 
	 */
	 @Override
	  public Iterator<Zeichen> iterator() {
	    return null;
	  }
	
	 /** Es werden die Positionen des uebergebenen Zeichens in dem
	  * Wort berechnet, die Positionen werden von 0 an gezaehlt.
	  * @param n zu suchendes Zeichen
	  * @return alles Positionen von n im Wort
	  */
	public List<Integer> positionenVon(Zeichen n){
		return null;
	}
	
	/** Im Wort wird an der Position pos das Zeichen durch das Wort w
	 * ersetzt. Sollte es die Position nicht geben, wird eine
	 * IllegalStateException geworfen.
	 * @param pos Position des Zeichens, das ersetzt werden soll
	 * @param w einzusetzendes Wort
	 * @return dieses Wort mit Ersetzung
	 */
	public Wort ersetzeAnPositionMit(int pos, Wort w) {
    return this;
	}
	
	
	 /** Laenge des Wortes.
	  * 
	  * @return Anzahl der Zeichen des Wortes.
	  */
	public int laenge() {
		return 0;
	}
		
	/** Es wird ein neues Wort beginnend ab der Position start inklusive
	 * bis zur Position ende exklusive zurueckgegeben. Sollte eine Position
	 * nicht existieren, wird ein IllegalStateException geworfen.
	 * @param start ab inklusive dieser Position beginnt das neue Wort
	 * @param ende exklusive dieser Position endet das Wort
	 * @return neues Wort (keine tiefe Kopie) ab start bis ende 
	 * @throws IllegalStateException
	 */
	public Wort vonBis(int start, int ende) {
	  return null;
	}
	
	/** Gibt das Zeichen an der Position pos zurueck, die Positionen beginnen
	 * bei 0. Existiert die Position nicht, wird eine IllegalStateException 
	 * geworfen.
	 * @param pos Position an der das Zeichen berechnet wird
	 * @return Zeichen an der Position pos
	 * @throws IllegalStateException
	 */
	public Zeichen at(int pos) {
	  return null;
	}
	
	/** Loescht das Zeichen an der Position pos, die Positionen beginnen
   * bei 0. Existiert die Position nicht, wird eine IllegalStateException 
   * geworfen.
   * @param pos Position an der das Zeichen geloescht wird
   * @return Wort ohne geloeschtes Zeichen
   * @throws IllegalStateException
   */
	public Wort loeschen(int pos) {
	  return this;
	}

	@Override
  public String toString() {
		return null;
	}
	
	/** String-Repraesentation des Wortes, bei dem Leerzeichen durch
	 *  /space ersetzt werden. 
	 * @return zugehoeriger String mit ersetzten Leerzeichen
	 */
  public String toFile() {
    return null;
  }
	
  /** String-Repraesentation des Wortes, das leere Wort wird durch
   *  ein Epsilon ausgegeben. 
   * @return zugehoeriger String, Leerzeichen als Epsilon
   */
  public String toGui() {
    if (this.laenge() == 0) {
      return "\u03B5";
    }
    return this.toString();
  }
  
	@Override
	public Wort clone() {
	  return null;
	}

  @Override
  public int hashCode() {
    return 0;
  }

  @Override
  public boolean equals(Object obj) {
    return false;
  }
}
